#!/bin/bash

interface=''
name=''

download_rate() {
	tc qdisc add dev $interface handle ffff: ingress
	tc filter add dev $interface parent ffff: protocol ip prio 50 u32 match ip src 0.0.0.0/0 police rate $1 burst 1m drop flowid :1
}

upload_rate() {
	tc qdisc add dev $interface root handle 1: htb default 10
	tc class add dev $interface parent 1:0 classid 1:10 htb rate $1
	tc filter add dev $interface protocol ip handle 1: parent 1: prio 1 cgroup
}

while [ "$1" ]; do
	case "$1" in
		net)
			shift
			shift
			;;
		veth)
			shift
			interface=$1
			shift
			;;
		uploadRate)
			shift
			upload_rate $1
			shift
			;;
		downloadRate)
			shift
			download_rate $1
			shift
			;;
		*)
			name=$1
			echo "$name"
			shift
			;;
		esac
done
